#ifndef _fileode_h
#define _fileode_h
#include"func.h"
#include"zdynsys.h"


extern const int odetrajtype;
extern const int odevartrajtype;
extern const int odevectfieldstype;
//  these constants are used to described the type of the file
//   each file starts with parameter record - refered to as <param>
// const int odetrajtype=1;        // records  x
// const int odevartrajtype=2;     // record x,dP(x)

// const int odevectfieldstype=3;  //  record x,sec,vect[1]..vect[..],
              //  + (if param.multipliers)  factor[1]..factor[..]
              // <x> is on section, vect[] are also on section, (at x)
              // factors: dP(x->x_next)(x)vect[i]= factor[i]*vect[i](at next point)
              // in the file
              //  for the last point factors are set to 1




typedef struct
 {
  int type;
  int dim;
  double h;
  int method;
  int order;
  int step;
  double tmax;
  int poincmap;
  double sec[MAX_DIM+1];
  int num_vect_fields;  // the number of vector fields
  int multipliers; // important for type==odevectfieldstype, tell if
                   // expansion(contraction) rates are written to file
} header_of_data_type;

int zgleof(FILE *f);
// my feof - function
// standard feof - returns 1 when during reading we meet EOF
// my function test if in the next reading I will get EOF
//  this is what I need in various loops reading lists of vectors etc

void erasefile(const char fname[] );

int readheader(ifstream &ftext,header_of_data_type *header);
int readheader(FILE *fbin,header_of_data_type *header);
int readheader(const char filename[],int bin,header_of_data_type *header);
// the header is read from <filename>
// if bin - then <filename> is binary, otherwise the file is text
//// RETURN : 1 - when the header was read
///           0 - otherwise

int readrecord(FILE *fbin,header_of_data_type param,double x[],double sec[],
    double vect[][MAX_DIM+1],double factors[]);
// depending on param.type
//  <vect> is either - Df or list of vectors
//  factors - are used only for  param.type==odevectfieldstype
//                                  param.multipliers==1
//  <factors[i]> - is a multiplier for the i-th vector field


int readrecord(FILE *fbin,header_of_data_type param,double x[]);

int readrecord(FILE *fbin,header_of_data_type param,double x[],
  double dp[MAX_DIM+1][MAX_DIM+1]);

int readrecord(ifstream &ftext,header_of_data_type param,double x[],double sec[],
    double vect[][MAX_DIM+1],double factors[]);
// depending on param.type
//  vect is either - Df
//   or list of vectors
//  factors - are used only for  param.type==odevectfieldstype
//                                  param.multipliers==1

int readrecord(ifstream &ftext,header_of_data_type param,double x[]);


int readrecord(ifstream &ftext,header_of_data_type param,double x[],
    double dp[][MAX_DIM+1]);


int saveheader(ofstream &report,header_of_data_type *header);
// function writes the header of traj data to  text file <report>

int saveheader(FILE *fbin,header_of_data_type *header);
// function writes the header of traj data to binary file <fbin>

void savetrajvar(Ode &ode,int calcvar,double xs[],double h,int method,int order,
   int step,  double tmax,int poincmap,double sec[],const char* fname,int bin);
// function saves to the file <fname> the trajectory of <xs>
// <ode>-differential equation
// if<poincmap> then we trajectory ends when <sec> is reached in <UP> direction
//   or the time > tmax
// if<!poincmap> then the trajectory up to time tmax is saved
// <step> - trajectory is save for time-steps being multiplies of <step>
// if<bin> - then we use binary file otherwise text file is used
//////////////////////////
// in file we have :
//  dim,h,method,order,step,tmax,poincmap,sec
//  and the points from trajectory (p_i), and D\varphi(t_poinc(p_i),*)(p_i)
//  between consequtive times



char *trajfname(const char* odedescription,char* fname,int maxlenfname,int pno,int bin,
                                             int type,int workfile);
// pno - for example the point number, or some other integer used to
//       differentiate trajectories
// possible values of type - odetrajtype=1;
//            odevartrajtype=2;
//             odevectfieldstype=3;


int changesamplingstep(int step);


void saveodepoinctraj(Ode &ode,double h,double sec[],double xs[],double tmax,
    int pno, char *fname,int maxlenfname,int *bin,int withdf  =-1);
// this function compute and saves the trajectory for the Poincare map
//  defined by <ode>  and <sec>
// it is assumed that the section is UP
//  h - time step
// xs - starting point
// tmax - the maximum return time allowed
// pno - the number used to differentiate points - just to produce different
//       file names
// withdf - -1 computer will ask the question if we want to save jAcobian
//           matrix of the flow
//           0 - the Jacobian matrix is not save with the trajectory
//           1 - the Jacobian matrix is saved with trajectory (necessary)
//              if we want to use <fname> as the basis for construction of
//              invariant vector fields
//  maxlenfname - the length (the size of fname[]) of the variable fname
//
// On output:
//  <fname> - is the name of the saved trajectory
//  bin - tells if the file <fname> is binary


#endif /*_fileode_h */
